Name:           pmd
Epoch:          0
Version:        5.4.1
Release:        %mkrel 5
Group:          Development/Java
Summary:        Scans Java source code and looks for potential problems
License:        BSD and ASL 2.0 and LGPLv3+
URL:            http://pmd.sourceforge.net/
BuildArch:      noarch

Source0:        http://downloads.sourceforge.net/project/pmd/pmd/%{version}/pmd-src-%{version}.zip

# fix api incompatibilities with newer saxon
# not sent upstream
Patch1:         0001-fdr-mga-Port-to-current-saxon.patch
Patch2:         javadoc-stack.patch

BuildRequires:  maven-local
BuildRequires:  mvn(com.beust:jcommander)
BuildRequires:  mvn(commons-io:commons-io)
BuildRequires:  mvn(jaxen:jaxen)
BuildRequires:  mvn(junit:junit)
BuildRequires:  mvn(net.java.dev.javacc:javacc)
BuildRequires:  mvn(net.sf.saxon:saxon)
BuildRequires:  mvn(net.sourceforge.pmd:pmd-build)
BuildRequires:  mvn(org.apache.ant:ant)
BuildRequires:  mvn(org.apache.ant:ant-testutil)
BuildRequires:  mvn(org.apache.commons:commons-lang3)
BuildRequires:  mvn(org.apache.maven.doxia:doxia-module-markdown)
BuildRequires:  mvn(org.apache.maven.plugins:maven-antrun-plugin)
BuildRequires:  mvn(org.apache.maven.plugins:maven-assembly-plugin)
BuildRequires:  mvn(org.apache.maven.plugins:maven-site-plugin)
BuildRequires:  mvn(org.codehaus.mojo:build-helper-maven-plugin)
BuildRequires:  mvn(org.jacoco:jacoco-maven-plugin)
BuildRequires:  mvn(org.mozilla:rhino)
BuildRequires:  mvn(org.ow2.asm:asm)
BuildRequires:  mvn(org.sonatype.oss:oss-parent:pom:)

%description
PMD scans Java source code and looks for potential problems like:
* Possible bugs: empty try/catch/finally/switch statements
+ Dead code: unused local variables, parameters and private methods
+ Suboptimal code: wasteful String/StringBuffer usage
+ Overcomplicated expressions: unnecessary if statements, for loops
  that could be while loops
+ Duplicate code: copied/pasted code means copied/pasted bugs

PMD has plugins for JDeveloper, Eclipse, JEdit, JBuilder, BlueJ,
CodeGuide, NetBeans/Sun Java Studio Enterprise/Creator, IntelliJ IDEA,
TextPad, Maven, Ant, Gel, JCreator, and Emacs.

%package javadoc
Summary:        API documentation for %{name}

%description javadoc
API documentation for %{name}.

%prep
%setup -q -n %{name}-src-%{version}
%patch1 -p1
%patch2 -p1

# remove all binary libs
find . -name "*.jar" -exec rm -f {} \;
find . -name "*.class" -exec rm -f {} \;

%mvn_alias : pmd:pmd

%pom_xpath_remove pom:build/pom:extensions

%pom_xpath_set pom:parent/pom:version %{version} */pom.xml

sed -i 's/net.sourceforge.saxon/net.sf.saxon/' `find -name pom.xml`

%pom_xpath_set -r '//pom:property[@name="javacc.jar"]/@value' `xmvn-resolve net.java.dev.javacc:javacc`

%build
# tests require com.github.tomakehurst:wiremock
%mvn_build -f -- -P!jdk9-disabled

%install
%mvn_install

%files -f .mfiles
%license LICENSE NOTICE

%files javadoc -f .mfiles-javadoc
%license LICENSE NOTICE



%changelog
* Fri Jun 03 2016 daviddavid <daviddavid> 0:5.4.1-5.mga6
+ Revision: 1020152
- add and adapt patch from fedora to fix build against current saxon 9.4.0.9

  + neoclust <neoclust>
    - Second rebuild of the java stack

* Thu Feb 25 2016 pterjan <pterjan> 0:5.4.1-3.mga6
+ Revision: 978795
- Set stack to 1M else we get a stack overflow on i586

  + neoclust <neoclust>
    - First rebuild of the java stack
    - sync package pmd with fedora

  + umeabot <umeabot>
    - Mageia 6 Mass Rebuild

  + daviddavid <daviddavid>
    - sync with fc22 (update to 5.2.3)
    - fix owner of maven-poms dir and java dir
    - Sync with fc21 (update to 5.1.2)
    - use better macro to remove all binary libs

* Wed Oct 15 2014 umeabot <umeabot> 0:5.0.5-4.mga5
+ Revision: 742088
- Second Mageia 5 Mass Rebuild

* Tue Sep 16 2014 umeabot <umeabot> 0:5.0.5-3.mga5
+ Revision: 687688
- Mageia 5 Mass Rebuild

* Tue Oct 22 2013 umeabot <umeabot> 0:5.0.5-2.mga4
+ Revision: 544944
- Mageia 4 Mass Rebuild

* Tue Oct 15 2013 dmorgan <dmorgan> 0:5.0.5-1.mga4
+ Revision: 500425
- New version

* Sun Jan 13 2013 umeabot <umeabot> 0:4.2.5-3.mga3
+ Revision: 377951
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Mon Nov 28 2011 dmorgan <dmorgan> 0:4.2.5-2.mga2
+ Revision: 173969
- Add jaxen  in the classpath
- Versionnate java requires
- Fix typo
- New version
  Sync with fedora/opensuse

  + gil <gil>
    - * correct group in main package
      * used new mvn macro
      * added %%pre script for unversioned javadoc symlink

* Mon Jan 17 2011 dmorgan <dmorgan> 0:4.2.1-2.0.5.mga1
+ Revision: 21736
- imported package pmd


* Fri Dec 03 2010 Oden Eriksson <oeriksson@mandriva.com> 0:4.2.1-2.0.5mdv2011.0
+ Revision: 607185
- rebuild

* Wed Mar 17 2010 Oden Eriksson <oeriksson@mandriva.com> 0:4.2.1-2.0.4mdv2010.1
+ Revision: 523691
- rebuilt for 2010.1

* Mon Oct 05 2009 Funda Wang <fwang@mandriva.org> 0:4.2.1-2.0.3mdv2010.0
+ Revision: 453746
- rebuild

  + Christophe Fergeau <cfergeau@mandriva.com>
    - rebuild

* Thu Aug 07 2008 Thierry Vignaud <tv@mandriva.org> 0:4.2.1-2.0.1mdv2009.0
+ Revision: 265471
- rebuild early 2009.0 package (before pixel changes)

* Mon Apr 21 2008 David Walluck <walluck@mandriva.org> 0:4.2.1-0.0.1mdv2009.0
+ Revision: 196032
- 4.2.1

* Fri Jan 25 2008 Alexander Kurtakov <akurtakov@mandriva.org> 0:4.0-0.0.4mdv2008.1
+ Revision: 157960
- fix build - BR asm2

  + Olivier Blin <oblin@mandriva.com>
    - restore BuildRoot

  + Thierry Vignaud <tv@mandriva.org>
    - kill re-definition of %%buildroot on Pixel's request

  + Anssi Hannula <anssi@mandriva.org>
    - buildrequire java-rpmbuild, i.e. build with icedtea on x86(_64)

* Sat Sep 15 2007 Anssi Hannula <anssi@mandriva.org> 0:4.0-0.0.2mdv2008.0
+ Revision: 87336
- rebuild to filter out autorequires of GCJ AOT objects
- remove unnecessary Requires(post) on java-gcj-compat

* Wed Jul 25 2007 David Walluck <walluck@mandriva.org> 0:4.0-0.0.1mdv2008.0
+ Revision: 55248
- 4.0

* Wed Jul 18 2007 Anssi Hannula <anssi@mandriva.org> 0:3.6-1.3.2mdv2008.0
+ Revision: 53204
- use xml-commons-jaxp-1.3-apis explicitely instead of the generic
  xml-commons-apis which is provided by multiple packages (see bug #31473)

* Wed Jul 04 2007 David Walluck <walluck@mandriva.org> 0:3.6-1.3.1mdv2008.0
+ Revision: 47972
- Import pmd



* Mon Mar 26 2007 Matt Wringe <mwringe@redhat.com> - 0:3.6-1jpp.3
- Fix unowned doc directory for pmd

* Mon Mar 19 2007 Matt Wringe <mwringe@redhat.com> - 0:3.6-1jpp.2
- Add missing jakarta-commons-oro build requires

* Tue Mar 13 2007 Jeff Johnston <jjohnstn@redhat.com> - 0:3.6-1jpp.1
- Updated per Fedora package review process
- Resolves: #227109

* Mon Jun 19 2006 Deepak Bhole <dbhole@redhat.com> - 0:3.6-1jpp
- Upgrade to 3.6

* Fri Mar 10 2006 Fernando Nasser <fnasser@redhat.com> - 0:3.3-2jpp
- First JPP 1.7 build

* Wed Nov 09 2005 Ralph Apel <r.apel at r-apel.de> - 0:3.3-1jpp
- Upgrade to 3.3
- Fix Groups

* Tue Feb 22 2005 Laurent Goujon <laurent at gobio2.net> - 2.3-1jpp
- Upgrade to 2.3
- Use bin/build.xml

* Mon Sep 13 2004 Ralph Apel <r.apel at r-apel.de> - 1.9-2jpp
- Drop saxpath requirements
- Require jaxen >= 0:1.1
- Relax some versioned requirements

* Wed Aug 25 2004 Fernando Nasser <fnasser@redhat.com> - 1.9-1jpp
- Upgrade to 1.9

* Wed Aug 24 2004 Fernando Nasser <fnasser@redhat.com> - 0:1.5-4jpp
- Rebuild with Ant 1.6.2

* Fri Aug 06 2004 Ralph Apel <r.apel at r-apel.de> - 1.5-3jpp
- Void change

* Tue Jun 01 2004 Randy Watler <rwatler at finali.com> - 1.5-2jpp
- Upgrade to Ant 1.6.X

* Wed Mar 24 2004 Ralph Apel <r.apel at r-apel.de> 1.5-1jpp
- first JPackage release
